diff --git a/src/backend/storage/buffer/bufmgr.c b/src/backend/storage/buffer/bufmgr.c
index c070278..3ef5cdb 100644
--- a/src/backend/storage/buffer/bufmgr.c
+++ b/src/backend/storage/buffer/bufmgr.c
@@ -1225,7 +1225,9 @@ BufferSync(int flags)
 	 * buffers.  But at shutdown or end of recovery, we write all dirty
 	 * buffers.
 	 */
-	if (!((flags & CHECKPOINT_IS_SHUTDOWN) || (flags & CHECKPOINT_END_OF_RECOVERY)))
+	if (!((flags & CHECKPOINT_IS_SHUTDOWN) ||
+		  (flags & CHECKPOINT_END_OF_RECOVERY) ||
+		  (flags & CHECKPOINT_FORCE)))
 		mask |= BM_PERMANENT;
 
 	/*
